use std::io::Read as _;

use actix_files::NamedFile;
use actix_web::{
    body::MessageBody,
    dev::{self, ServiceResponse},
    middleware::ErrorHandlerResponse,
    Responder, Result,
};

pub fn bad_request<B: MessageBody>(
    mut res: dev::ServiceResponse<B>,
) -> Result<ErrorHandlerResponse<B>> {
    let mut new_resp = NamedFile::open("static/errors/400.html")?;
    let mut body = String::new();
    new_resp.read_to_string(&mut body);

    res.response_mut().set_body(body);

    /*     let (req, res) = res.into_parts();
    res.set_body(body);

    let response = ServiceResponse::new(req, res)
        .map_into_boxed_body()
        .map_into_right_body(); */

    Ok(ErrorHandlerResponse::Response(
        res.map_into_boxed_body().map_into_right_body(),
    ))
}

pub fn not_found<B>(res: dev::ServiceResponse<B>) -> Result<impl Responder> {
    let new_resp = NamedFile::open("static/errors/404.html")?
        .customize()
        .with_status(res.status())
        .respond_to(res.request());

    Ok(new_resp)
}

pub fn internal_server_error<B: MessageBody>(
    res: dev::ServiceResponse<B>,
) -> Result<ErrorHandlerResponse<B>> {
    let mut new_resp = NamedFile::open("static/errors/500.html")?;
    let mut body = String::new();
    new_resp.read_to_string(&mut body);
    let (req, res) = res.into_parts();
    res.set_body(body);

    let response = ServiceResponse::new(req, res)
        .map_into_boxed_body()
        .map_into_right_body();

    Ok(ErrorHandlerResponse::Response(response))
}
